package com.example.demo;

public class Instructor extends Person implements Teacher {

    public Instructor(long id, String name){
        super(id, name);
    }

    public void teach(Learner learner, double numberOfHours) {
        learner.learn(numberOfHours);
    }

    public void lecture(Iterable<? extends Learner> learners, double numberOfHours){
        double numberOfHoursPerLearner = learners.spliterator().getExactSizeIfKnown() / numberOfHours;

        for (Learner pupil : learners) {
            pupil.learn(numberOfHoursPerLearner);
        }
    }
}
