package com.example.demo;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

@RunWith(SpringRunner.class)
@SpringBootTest
public class StudentConfigTest {
    private Students currentStudents, previousStudents;

    @Autowired
    StudentConfig studentConfig;


    @Before
    public void before(){
        currentStudents = studentConfig.currentStudents();
        previousStudents = studentConfig.previousStudents();
    }

    @Test
    public void contextTest(){
        Assert.assertNotNull(studentConfig.currentStudents());
    }

    @Test
    public void testCurrentStudents(){
        Assert.assertEquals(currentStudents, studentConfig.currentStudents());
        Assert.assertNotEquals(currentStudents, previousStudents);
    }

}
